package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesConsistencyAffirmRecord;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/04 19:25
 * @Description:
 **/
public interface IConsistencyAffirmRecordService {
    /**
     * 一致性确认记录报表
     * 按条件分页查询一致性确认记录详情
     * @param consistencyAffirmRecord
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询一致性确认记录详情", notes = "按条件分页查询一致性确认记录详情")
    ListPager<MesConsistencyAffirmRecord> queryConsistencyAffirmRecordByPager(MesConsistencyAffirmRecord consistencyAffirmRecord, Pager pager);


    /**
     * 品质确认
     * @param ids
     * @param qualityCheck
     * @return
     */
    int updateQualityCheck(String[] ids,Integer qualityCheck);

    /**
     *  班组确认
     * @param ids
     * @param shiftGroupCheck
     * @return
     */
    int updateShiftGroupCheck(String[] ids,Integer shiftGroupCheck);
}
