package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesExteriorScratchProofDetail;
import cn.estsh.i3plus.ext.mes.pojo.model.MesExteriorScratchProofDetailModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/03/12
 * @Description:
 **/
public interface IExteriorScratchProofDetailService {
    /**
     * 外观防划伤明细报表
     * 按条件分页查询外观防划伤明细详情
     * @param exteriorScratchProofDetail
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询外观防划伤明细详情", notes = "按条件分页查询外观防划伤明细详情")
    ListPager<MesExteriorScratchProofDetailModel> queryExteriorScratchProofDetailByPager(MesExteriorScratchProofDetail exteriorScratchProofDetail, Pager pager);


    /**
     * 品质确认
     * @param ids
     * @param qualityCheck
     * @return
     */
    int updateQualityCheck(String[] ids,Integer qualityCheck);

    /**
     *  班组确认
     * @param ids
     * @param shiftGroupCheck
     * @return
     */
    int updateShiftGroupCheck(String[] ids,Integer shiftGroupCheck);
}
