package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesWorkCenterContainerLocation;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IWorkCenterContainerLocationService {

    /**
     * 按条件分页查询产线托盘位置信息
     *
     * @param workCenterContainerLocation 查询条件
     * @param pager 分页条件
     * @return 产线托盘位置分页数据
     */
    @ApiOperation(value = "按条件分页查询产线托盘位置信息", notes = "按条件分页查询产线托盘位置信息")
    ListPager<MesWorkCenterContainerLocation> queryWorkCenterContainerLocationByPager(MesWorkCenterContainerLocation workCenterContainerLocation, Pager pager);

    /**
     * 新增产线托盘位置信息
     * @param workCenterContainerLocation 产线托盘位置信息
     * @return 产线托盘位置数据
     */
    @ApiOperation(value = "新增产线托盘位置信息", notes = "新增产线托盘位置信息")
    MesWorkCenterContainerLocation insertWorkCenterContainerLocation(MesWorkCenterContainerLocation workCenterContainerLocation);

    /**
     * 更新产线托盘位置信息
     * @param workCenterContainerLocation 产线托盘位置信息
     * @return 产线托盘位置数据
     */
    @ApiOperation(value = "更新产线托盘位置信息", notes = "更新产线托盘位置信息")
    MesWorkCenterContainerLocation updateWorkCenterContainerLocation(MesWorkCenterContainerLocation workCenterContainerLocation);

    /**
     * 根据id启用或禁用产线托盘位置信息
     * @param id 产线托盘位置信息ID
     * @param status 状态
     * @param organizeCode 组织代码
     * @param userName 操作人
     * @return 结果
     */
    @ApiOperation(value = "根据id启用或禁用产线托盘位置信息", notes = "根据id启用或禁用产线托盘位置信息")
    int updateWorkCenterContainerLocationValidById(Long id, Integer status, String organizeCode, String userName);

}
