package cn.estsh.i3plus.ext.mes.api.base.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesTimeSegmentStatistics;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.text.ParseException;

/**
 * @Description : 分时段统计方式
 * @Reference :
 * @Author : jiaqi.hou
 * @CreateDate : 2023/02/06 13:42
 * @Modify:
 **/
public interface IJxTimeSegmentStatisticsService {

    /**
     * 新增
     * @param timeSegmentStatistics
     * @param userName
     * @return
     */
    void insert(MesTimeSegmentStatistics timeSegmentStatistics, String organizeCode, String userName) throws ParseException;

    /**
     * 删除
     * @param ids
     */
    void deleteByIds(Long[] ids, String userName);

    /**
     * 修改
     * @param timeSegmentStatistics
     */
    void update(MesTimeSegmentStatistics timeSegmentStatistics, String organizeCode, String userName) throws ParseException;

    /**
     * 禁用
     * @param ids
     */
    void doDisable(Long[] ids, String userName);

    /**
     * 启用
     * @param ids
     */
    void doEnable(Long[] ids, String organizeCode, String userName);

    /**
     * 查询
     * @param timeSegmentStatistics
     * @param pager
     * @return
     */
    ListPager<MesTimeSegmentStatistics> queryByPager(MesTimeSegmentStatistics timeSegmentStatistics, Pager pager);

}
