package cn.estsh.i3plus.ext.mes.api.busi.bu3;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesProdDataToSoftAdapterCfg;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxProdDataToSoftAdapterCfgModel;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxProdDataToSoftAdapterDataModel;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.model.softswitch.SuitModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

public interface ISxProdDataToSoftAdapterCfgService {

    /**
     * 查询生产数据回传软适配配置信息集合
     * @param organizeCode 工厂代码
     */
    @ApiOperation(value = "查询生产数据回传软适配配置信息集合", notes = "查询生产数据回传软适配配置信息集合")
    List<MesProdDataToSoftAdapterCfg> queryProdDataToSoftAdapterCfgList(String organizeCode);

    /**
     * 调用SUIT接口
     * @param data 数据
     * @param cfgModel 配置
     * @param suit 接口参数
     * @return 结果
     */
    @ApiOperation(value = "调用SUIT接口", notes = "调用SUIT接口")
    BaseResultBean executeBsSuitCaseByCloud(SxProdDataToSoftAdapterDataModel data, SxProdDataToSoftAdapterCfgModel cfgModel, SuitModel suit);

}
