package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesModuleExcelManage;
import cn.estsh.i3plus.ext.mes.pojo.model.ModuleExcelManageModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2019/11/21 11:28 上午
 * @Description:
 **/
public interface IModuleExcelManageDao {

    /**
     * 查询模块EXCEL管理数量
     * @param moduleExcelManage 模块EXCEL管理信息
     * @return 数量
     */
    @ApiOperation(value = "查询模块EXCEL管理数量", notes = "查询模块EXCEL管理数量")
    int queryModuleExcelManageByPagerCount(MesModuleExcelManage moduleExcelManage);

    /**
     * 查询模块EXCEL管理信息集合
     * @param moduleExcelManage 查询条件
     * @param pager 分页条件
     * @return 模块EXCEL管理信息集合
     */
    @ApiOperation(value = "查询模块EXCEL管理信息集合", notes = "查询模块EXCEL管理信息集合")
    List<ModuleExcelManageModel> queryModuleExcelManageByPager(MesModuleExcelManage moduleExcelManage, Pager pager);
}
