package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesPartCheckDetail;
import cn.estsh.i3plus.ext.mes.pojo.model.PartCheckDetailModel;
import cn.estsh.i3plus.ext.mes.pojo.model.PartCheckDetailModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * 文件描述 物料点检明细
 *
 * @author xiangming.liao
 * @date 2021年09月06日 9:54
 */
public interface IPartCheckDetailDao {

    /**
     * @return int
     * @Description: 查询物料点检明细数量
     * @Param [detail]
     * @Date 2021/9/7 10:38
     **/
    @ApiOperation(value = "查询物料点检明细数量", notes = "查询物料点检明细数量")
    int queryPartCheckDetailByPagerCount(MesPartCheckDetail detail);

    /**
     * @return java.util.List<cn.estsh.i3plus.ext.mes.pojo.model.PartCheckDetailModel>
     * @Description: 查询物料点检明细集合
     * @Param [detail, pager]
     * @Date 2021/9/7 10:38
     **/
    @ApiOperation(value = "查询物料点检明细集合", notes = "查询物料点检明细集合")
    List<PartCheckDetailModel> queryPartCheckDetailByPager(MesPartCheckDetail detail, Pager pager);
}
